zoukankan      html  css  js  c++  java
  • LeetCode之“链表”:Intersection of Two Linked Lists

      此题扩展:链表有环,如何判断相交?

      参考资料:

        编程判断两个链表是否相交

        面试精选:链表问题集锦

      题目链接

      题目要求:

      Write a program to find the node at which the intersection of two singly linked lists begins.

      For example, the following two linked lists:

      A:          a1 → a2
                         ↘
                           c1 → c2 → c3
                         ↗            
      B:     b1 → b2 → b3
    

      begin to intersect at node c1. 

      Notes:

    • If the two linked lists have no intersection at all, return null.
    • The linked lists must retain their original structure after the function returns.
    • You may assume there are no cycles anywhere in the entire linked structure.
    • Your code should preferably run in O(n) time and use only O(1) memory.

      Credits:
      Special thanks to @stellari for adding this problem and creating all test cases.

      这道题即是求两个链表交点的典型题目。具体地,我们可以这样子做:

      1)求得两个链表的长度;

      2)将长的链表向前移动|lenA - lenB|步;

      3)两个指针一起前进,遇到相同的即是交点,如果没找到,返回nullptr。

      具体程序如下:

     1 /**
     2  * Definition for singly-linked list.
     3  * struct ListNode {
     4  *     int val;
     5  *     ListNode *next;
     6  *     ListNode(int x) : val(x), next(NULL) {}
     7  * };
     8  */
     9 class Solution {
    10 public:
    11     ListNode *getIntersectionNode(ListNode *headA, ListNode *headB) {
    12         if(!headA || !headB)
    13             return nullptr;
    14             
    15         int lenA = 0, lenB = 0;
    16         ListNode *startA = headA, *startB = headB;
    17         while(startA)
    18         {
    19             lenA++;
    20             startA = startA->next;
    21         }
    22         
    23         while(startB)
    24         {
    25             lenB++;
    26             startB = startB->next;
    27         }
    28         
    29         startA = headA;
    30         startB = headB;
    31         if(lenA > lenB)
    32         {
    33             for(int i = 0; i < lenA - lenB; i++)
    34                 startA = startA->next;
    35         }
    36         else
    37         {
    38             for(int i = 0; i < lenB - lenA; i++)
    39                 startB = startB->next;
    40         }
    41         
    42         while(startA && startB)
    43         {
    44             if(startA == startB)
    45                 return startA;
    46             startA = startA->next;
    47             startB = startB->next;
    48         }
    49         
    50         return nullptr;
    51     }
    52 };

      附上该题作者分析

      There are many solutions to this problem:

    • Brute-force solution (O(mn) running time, O(1) memory):

      For each node ai in list A, traverse the entire list B and check if any node in list B coincides with ai.

    • Hashset solution (O(n+m) running time, O(n) or O(m) memory):

      Traverse list A and store the address / reference to each node in a hash set. Then check every node bi in list B: if bi appears in the hash set, then bi is the intersection node.

    • Two pointer solution (O(n+m) running time, O(1) memory):
      • Maintain two pointers pA and pB initialized at the head of A and B, respectively. Then let them both traverse through the lists, one node at a time.
      • When pA reaches the end of a list, then redirect it to the head of B (yes, B, that's right.); similarly when pB reaches the end of a list, redirect it the head of A.
      • If at any point pA meets pB, then pA/pB is the intersection node.
      • To see why the above trick would work, consider the following two lists: A = {1,3,5,7,9,11} and B = {2,4,9,11}, which are intersected at node '9'. Since B.length (=4) < A.length (=6), pB would reach the end of the merged list first, because pB traverses exactly 2 nodes less than pA does. By redirecting pB to head A, and pA to head B, we now ask pB to travel exactly 2 more nodes than pA would. So in the second iteration, they are guaranteed to reach the intersection node at the same time.
      • If two lists have intersection, then their last nodes must be the same one. So when pA/pB reaches the end of a list, record the last element of A/B respectively. If the two last elements are not the same one, then the two lists have no intersections.

      Analysis written by @stellari.

  • 相关阅读:
    js学习(三)对象与事件
    js学习(二)
    js学习(一)
    SSM+Redis结构框架及概述
    javaBean、EJB、POJO
    flex布局时的居中问题
    layui后台管理系统的坑
    基于element的模糊查询
    vue数组的运用
    uni-app 图片上传(uploadFile)
  • 原文地址:https://www.cnblogs.com/xiehongfeng100/p/4602432.html
Copyright © 2011-2022 走看看